/*
 * AlibavaSOAP.h
 *
 *  Created on: 9 Jan 2011
 *      Author: lacasta
 */

#ifndef AlibavaSOAP_H_
#define AlibavaSOAP_H_

struct AlibavaSOAP_priv;

/**
 * This is the implementation of a SOAP server
 */
class AlibavaSOAP
{
    private:
        // This is an opaque struct that contains internal information
        AlibavaSOAP_priv *_priv;
    public:
        AlibavaSOAP( int port);
        virtual ~AlibavaSOAP();

        /// Starts serving
        void serve(bool threaded=true);

        /// Tells whether it is running or not
        bool is_running() const;

        /// Stops serving
        void stop_serving();

        /// Returns the error code if any
        int error();

        /// Returns an error string
        std::string strerror() const;
};
#endif /* AlibavaSOAP_H_ */
