/*
 * alibavaClient.h
 *
 *  Created on: Jan 21, 2014
 *      Author: lacasta
 */

#ifndef ALIBAVACLIENT_H_
#define ALIBAVACLIENT_H_
#include <iosfwd>
#include <vector>
#include <soapalibavaSOAPProxy.h>
#include "Histogram.h"

/*
 * This is a class that handles the communication with the alibava-gui
 * SOAP server
 */
class alibavaClient
{
    public:
        typedef std::vector<Histogram *> HstList;
    private:
        alibavaSOAPProxy *server;
        HstList histograms;

        void reset_histograms();
    public:
        alibavaClient();
        ~alibavaClient();

        void connect(const char *uri);
        int getStatus(ns1__Status &status);
        int setDataFile(const char *ofile);
        int stopRun();
        int startRun(ns1__RunType type, bool async, int nevt, int nbin, int xmin, int xmax, int nsample);
        int startPedestalRun(int nevt, bool async, int nbin=512, int xmin=-512, int xmax=512, int nsample=100);
        int startSourceRun(int nevt, bool async, int nbin=512, int xmin=-512, int xmax=512, int nsample=100);
        int startLaserRun(int nevt, bool async, int nbin=512, int xmin=-512, int xmax=512, int nsample=100);

        Histogram *get_histogram(int ix) { return histograms[ix]; }

};

std::ostream &operator<<(std::ostream &os, const ns1__Status &st);
#endif /* ALIBAVACLIENT_H_ */
